# $Id: Module.pm,v 1.1 2007/01/06 07:39:54 koba Exp $
#	Copyright(c) 2007 Satoshi Kobayashi, All rights reserved.

package XiuMai::Module;

use strict;
use vars qw($VERSION);

$VERSION = do { my @r = (q$Revision: 1.1 $ =~ /\d+/g);
				sprintf("%d." . "%02d" x $#r, @r) };

sub new {
	my $class = shift;
	my $self = bless {}, $class;
	$self->import_module('Core', '_default');
	return $self;
}

sub import_module {
	my $self = shift;
	my ($class, $prefix) = @_;
	$prefix ||= $class;
	eval qq(
		use XiuMai::Module::$class;
		\$self->{$prefix} = new XiuMai::Module::$class;
	);
	return qq(<p class="error">Module "$class" not found.</p>\n) if ($@);
	return '';
}

sub dispatch {
	my $self = shift;
	my ($mode, $name, $param, $value) = @_;
	if ($mode eq 'block' && $name eq 'import' && defined $param) {
		my ($class, $prefix) = split(/,\s*/, $param);
		return $self->import_module($class, $prefix);
	}
	return $self->{_default}->dispatch($mode, $name, $param, $value);
}

1;
