# $Id: Msg.pm,v 1.1.1.1 2006/12/17 09:35:21 koba Exp $
#	Copyright(c) 2006 Satoshi Kobayashi, All rights reserved.

package XiuMai::Msg;

use strict;
use FileHandle;
use vars qw($VERSION);

$VERSION = do { my @r = (q$Revision: 1.1.1.1 $ =~ /\d+/g);
				sprintf("%d." . "%02d" x $#r, @r) };

sub new {
	my $class = shift;
	my ($filename) = @_;
	my $self = {};

	my $fh = new FileHandle($filename)	or return;
	while (<$fh>) {
		chomp;
		next if (/^#/);
		my ($key, $value) = split(/:/, $_, 2);
		$self->{$key} = $value;
	}
	close($fh);

	return bless $self, $class;
}

sub get {
	my $self = shift;
	my ($key) = @_;

	my $format = $self->{$key}	or return $key;
	my @index = $format =~ /{\$(\d+)}/g;
	$format =~ s/{\$\d+}/%s/g;
	$format =~ s/\\n/\n/g;

	my @param;
	foreach (@index) {
		push(@param, $_[$_]);
	}

	return sprintf($format, @param);
}

1;
