# $Id: XiuMai.pm,v 1.5 2006/12/30 13:51:52 koba Exp $
#	Copyright(c) 2006 Satoshi Kobayashi, All rights reserved.

package XiuMai::Resource::XiuMai;

use strict;
use XiuMai::Resource::Text;
use XiuMai::XHTML::Text;
use XiuMai::Text;
use XiuMai::Util qw(cdata);
use FileHandle;
use vars qw($VERSION @ISA);

$VERSION = $XiuMai::VERSION;

@ISA = qw(XiuMai::Resource::Text);

sub new {
	my $class = shift;
	my ($self) = @_;
	return bless $self, $class;
}

sub _html {
	my $self = shift;

	my $text = new XiuMai::Text;
	$self->{html_body} = $text->parse($self->{text});

	my $html = new XiuMai::XHTML::Text($self);
	$self->{html}
		= $html->title($text->title)
			   ->as_string($self->{html_body});

	$self->{type}  = undef;
	$self->{size}  = length($self->{html});
	$self->{mtime} = undef;
	$self->{lang}  = [$html->content_language];

	return $self;
}

sub html_body {
	my $self = shift;
	return $self->{html_body};
}

sub update {
	my $self = shift;

	return if (! $self->w_ok);

	my $text = $self->{Request}->param('text');

	$self->{redirect_code} = 303;
	$self->{redirect_url}  = $self->url;

	if (! defined $text || ! length $text) {
		unlink($self->{path})	or return;
		$self->{redirect_url} = './';
		return $self;
	}

	my $fh = new FileHandle(">$self->{path}")	or return;
	print $fh $text;
	$fh->close;
	return $self;
}

1;
