# $Id: Text.pm,v 1.2 2006/12/17 16:17:02 koba Exp $
#	Copyright(c) 2006 Satoshi Kobayashi, All rights reserved.

package XiuMai::XHTML::Text;

use strict;
use XiuMai;
use XiuMai::XHTML::Resource;
use XiuMai::Util qw(cdata);
use FileHandle;
use vars qw($VERSION @ISA);

$VERSION = $XiuMai::VERSION;

@ISA = qw(XiuMai::XHTML::Resource);

sub new {
	my $class = shift;
	my $self = new XiuMai::XHTML::Resource(@_);
	return bless $self, $class;
}

sub text_form {
	my $self = shift;

	my $url    = cdata($self->{Resource}->url);
	my $text   = cdata($self->{Resource}->text);
	my $submit = cdata($self->msg('text.text_form.submit.label'));
	my $session_id = cdata($self->session_id);

	return <<"++";
<form method="post" action="$url">
<p><input name="session_id" type="hidden" value="$session_id" />
<textarea name="text" rows="32" cols="88">$text</textarea></p>
<p><input type="submit" value="$submit" /></p>
</form>
++
}

1;
